/*
 * Copyright 2010 JBoss, a divison Red Hat, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.errai.samples.rpcdemo.client.local;

import java.util.Map;

import javax.annotation.PostConstruct;
import javax.inject.Inject;

import org.errai.samples.rpcdemo.client.shared.TranslationRemoteService;
import org.errai.samples.rpcdemo.client.shared.TranslationResolver;
import org.jboss.errai.bus.client.api.RemoteCallback;
import org.jboss.errai.ioc.client.api.Caller;
import org.jboss.errai.ioc.client.api.EntryPoint;

import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.VerticalPanel;

@EntryPoint
public class RPCDemo {
  @Inject
  private Caller<TranslationRemoteService> translationService;

  @PostConstruct
  public void init() {

    final Label resultLabel = new Label();


    final Button btnTranslation = new Button("Get Translations", new ClickHandler() {
      public void onClick(ClickEvent clickEvent) {
    	  translationService.call(new RemoteCallback<Map<String, Map<String, String>>>() {

			@Override
			public void callback(Map<String, Map<String, String>> response) {
				System.out.println("Translations: " + response.toString());
				resultLabel.setText("Translations: " + response.toString());
			}
		}).getTranslations();
      }
    });
    
    final Button btnTranslationResolver = new Button("Get TranslationResolver", new ClickHandler() {
        public void onClick(ClickEvent clickEvent) {
      	  translationService.call(new RemoteCallback<TranslationResolver>() {

  			@Override
  			public void callback(TranslationResolver response) {
  				System.out.println("Translations: " + response.getTranslations().toString());
  				resultLabel.setText("Translations: " + response.getTranslations().toString());
  			}
  		}).getResolver();
        }
      });
    

    VerticalPanel vPanel = new VerticalPanel();

    HorizontalPanel appendTest = new HorizontalPanel();
    appendTest.add(btnTranslation);
    appendTest.add(btnTranslationResolver);
    appendTest.add(resultLabel);
    vPanel.add(appendTest);
    RootPanel.get().add(vPanel);
  }
}