/*
 * Copyright 2010 JBoss, a divison Red Hat, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.errai.samples.rpcdemo.server;

import java.util.HashMap;
import java.util.Map;

import org.errai.samples.rpcdemo.client.shared.TranslationRemoteService;
import org.errai.samples.rpcdemo.client.shared.TranslationResolver;
import org.jboss.errai.bus.server.annotations.Service;

@Service
public class RPCDemoService implements TranslationRemoteService {

	@Override
	public TranslationResolver getResolver() {
		TranslationResolver transResolver = new TranslationResolver();
		
		Map<String, Map<String, String>> allTranslations = getTranslations();
		transResolver.setTranslations(allTranslations);
		
		return transResolver;
	}

	@Override
	public Map<String, Map<String, String>> getTranslations() {
		//create map for german translations
		Map<String, String> deTranslations = new HashMap<String, String>();
		deTranslations.put("hello", "Hallo");
		deTranslations.put("one", "Eins");
		
		//create map for english translations
		Map<String, String> enTranslations = new HashMap<String, String>();
		enTranslations.put("hello", "Hello");
		enTranslations.put("one", "One");
		
		//put the translations together
		Map<String, Map<String, String>> allTranslations = new HashMap<String, Map<String,String>>();
		allTranslations.put("de", deTranslations);
		allTranslations.put("en", enTranslations);
		
		return allTranslations;
	}
 
}